Subject: Re: [Bug] branch.*.merge interpreted too strictly by tracking logic

From: Junio C Hamano <[email-masked]>
Date: Wed, 05 Feb 2014 13:05:04 -0800

Jeff King <[email-masked]> writes:

> Is it legal to put an unqualified ref there? A wise man once said[1]:
>
>   > Actually, it is broken in a lot of places. for-each-ref relies on
>   > the same code as "git status", "git checkout", etc, which will all
>   > fail to display tracking info. I believe the same code is also used
>   > for updating tracking branches on push. So I'm not sure if it was
>   > ever intended to be a valid setting.
>
>   It wasn't.  Some places may accept them gracefully by either being
>   extra nice or by accident.
>
> I don't recall us ever doing anything after that. I don't have a problem
> with making it work, of course, but I am not sure if it is really a bug.

Once people get used to us being extra nice in some places, other
less nice places start looking more and more like bugs. It is an
unfortunate fact of life, but fixing them up is a good thing for
users.  As long as we can make those less nice places nicer
uniformly without bending backwards or introducing unnecessary
ambiguities, that is, and I think this one can be done without
such downsides.